
/**
 * This class test the validity of names as consisting of 
 * a letter followed by zoro or more letters, hyphens and spaces
 * 
 * @author Bernd J. Krmer
 * @version 10.09.2003
 */
public class CustomerNames
{

	public boolean checkName(String name)
	{
	    boolean yes;
	    if (yes = !isEmptyString(name) && firstIsChar(name) && restIsNameChar(name))
	    {
	        printName (name);
	        return true;
	    } else
	    {
	        System.out.println("Illegal name!");
	        return false;
	    }
	}
	
	public void printName(String name)
	{
	    System.out.print(name.substring(0,1).
	         toUpperCase());
	    System.out.println(name.
	        substring(1,name.length()).toLowerCase());
	}
	    
	private boolean isLetter(char c)
	{
		return ((int) c > 64 && (int) c < 91) ||
		       ((int) c > 96) && ((int) c < 123);
	}
	
    private boolean isNameChar(char c)
	{
		return isLetter(c) || isSpace(c) || isHypen(c);
	}    

	private boolean isHypen(char c)
	{
		return (int) c == 45;
	}
	
    private boolean isSpace(char c)
	{
		return (int) c == 32;
	}
	
	private boolean isEmptyString(String name)
	{
	    return name.length() == 0;
	}
	
	private boolean firstIsChar(String name)
	{
	    return isLetter(name.charAt(0));
	}	
	
	private boolean restIsNameChar(String name)
	{
	    boolean yes = true;
	    for (int i = 1; i< name.length(); i++)
	    {
	        if (!isNameChar(name.charAt(i)))
	        {
	            yes = false;
	            break;
	        };
	    }
	    return yes;
	}	
}